diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/daemon/common/commonSwarming.ml ./src/daemon/common/commonSwarming.ml
--- ./src/daemon/common/commonSwarming.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/daemon/common/commonSwarming.ml	2006-05-25 20:48:14.000000000 +0200
@@ -1367,348 +1378,273 @@
       range_end = block_end;
       range_block = b;
       range_nuploading = 0;
-      range_current_begin = block_begin;
     }
   in
-
 (*  lprintf "New block %Ld-%Ld\n" block_begin block_end; *)
-  split_range range s.s_range_size;
-
-(*
-  let rec iter r =
-    lprintf "  Range %Ld-%Ld\n" r.range_begin r.range_end;
-    match r.range_next with
-      None -> ()
-    | Some r -> iter r
-  in
-  iter b.block_ranges;
-*)
 
   s.s_blocks.(i) <- PartialBlock b;
   if s.s_verified_bitmap.[i] < '1' then
-    set_bitmap_1 s i;
+    set_swarmer_bitmap_1 s i;
   if debug_all then lprintf_nl "NB[%s]" s.s_verified_bitmap;
   b
 
+(** Remove an interval from the beginning of a range, adding the size
+    of the removed part to the downloaded amount
+    Closed ranges are removed
+    When last range is removed, mark the block for verification *)
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         next_range (internal)                         *)
-(*                                                                       *)
-(*************************************************************************)
-
-(*
-let next_range f r =
-  match r.range_next with
-    None -> ()
-  | Some rr -> f rr
-        *)
-
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         add_all_downloaded                            *)
-(*                                                                       *)
-(*************************************************************************)
-
-(*
-let add_all_downloaded t old_downloaded =
-  let new_downloaded = t.t_downloaded in
-  if new_downloaded <> old_downloaded then
-    add_file_downloaded t.t_file (new_downloaded -- old_downloaded)
-    *)
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         range_received (internal)                     *)
-(*                                                                       *)
-(*************************************************************************)
-
-let range_received maybe_t r chunk_begin chunk_end =
+let range_received maybe_t r interval_begin interval_end =
 (*  lprintf "   range_received: %Ld-%Ld for %Ld-%Ld\n"
-    chunk_begin chunk_end r.range_begin r.range_end;  *)
-  if r.range_begin < chunk_end && r.range_end > chunk_begin then begin
-
+    interval_begin interval_end r.range_begin r.range_end;  *)
+  (* interval overlap with the beginning of range ? *)
+  (* was: r.range_begin < interval_end && r.range_end > interval_begin *)
+  if r.range_begin >= interval_begin && 
+    r.range_begin < interval_end then begin
 (*      lprintf "... entered\n"; *)
-      let new_current_begin =
-        max (min chunk_end r.range_end) r.range_current_begin in
-      let downloaded = new_current_begin -- r.range_current_begin in
-      let b = r.range_block in
-      let s = b.block_s in
-      add_file_downloaded maybe_t s downloaded;
-      b.block_remaining <- b.block_remaining -- downloaded;
-      r.range_current_begin <- new_current_begin;
-      if r.range_current_begin = r.range_end then begin
-          (match r.range_next with
-              None -> ()
-            | Some rr -> rr.range_prev <- r.range_prev);
-          (match r.range_prev with
-              None ->
-                begin
-                  match r.range_next with
-                    None ->
-                      begin
-                        match s.s_blocks.(b.block_num) with
-                          PartialBlock _ | EmptyBlock ->
-
-                            begin
-                              match s.s_networks with
-                                [] -> assert false
-                              | t :: _ when t.t_primary ->
-                                  begin
-                                    match t.t_verifier with
-                                      NoVerification ->
-                                        set_verified_block s b.block_num
-                                    | _ ->
-                                        set_completed_block (Some t) s b.block_num;
-                                        must_verify_block s b.block_num false
-                                  end
-                              | _ -> ()
-                            end
-                        | _ -> ()
-                      end
-                  | Some rr -> b.block_ranges <- rr
-                end;
-            | Some rr -> rr.range_next <- r.range_next);
-          r.range_next <- None;
-          r.range_prev <- None;
-        end (* else begin
-          lprintf " ... new range %Ld-%Ld\n" r.range_current_begin r.range_end;
-        end *)
-    end
+    let new_current_begin =
+      max (min interval_end r.range_end) r.range_begin in
+    let downloaded = new_current_begin -- r.range_begin in
+    let b = r.range_block in
+    let s = b.block_s in
+    add_file_downloaded maybe_t s downloaded;
+    b.block_remaining <- b.block_remaining -- downloaded;
+    r.range_begin <- new_current_begin;
+    if r.range_begin = r.range_end then begin
+      (* range completed, unlink it *)
+      (match r.range_next with
+       | Some rr -> rr.range_prev <- r.range_prev
+       | None -> ());
+      (match r.range_prev with
+       | Some rr -> rr.range_next <- r.range_next
+       | None ->
+	   (* that was the first range of the block *)
+           match r.range_next with
+           | Some rr -> (* fix block's first range *)
+	       b.block_ranges <- rr
+           | None ->
+	       (* that was the last remaining range of the block *)
+               (match s.s_blocks.(b.block_num) with
+                | PartialBlock _ | EmptyBlock ->
+                    (match s.s_networks with
+		     | t :: _ -> 
+			 assert(t.t_primary);
+                         (match t.t_verifier with
+			  | NoVerification ->
+                              set_verified_block s b.block_num
+			  | _ ->
+                              set_completed_block (Some t) s b.block_num;
+                              must_verify_block s b.block_num)
+		     | [] -> assert false)
+                | _ -> () ));
+      r.range_next <- None;
+      r.range_prev <- None;
+    end (* else begin
+           lprintf " ... new range %Ld-%Ld\n" r.range_begin r.range_end;
+           end *)
+  end
 
+(** Split a range at [cut_pos] offset, if needed;
+    ranges stay linked together *)
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         set_present_block (internal)                  *)
-(*                                                                       *)
-(*************************************************************************)
+let rec split_range r cut_pos =
+(*  lprintf "   split_range: cut_pos %Ld\n" cut_pos; *)
+  if r.range_begin < cut_pos && r.range_end > cut_pos then
+    (* "right" half *)
+    let split_r = {
+      range_block = r.range_block;
+      range_nuploading = 0;
+      range_next = r.range_next;
+      range_prev = Some r;
+      range_begin = cut_pos;
+      range_end = r.range_end;
+    } in
+    (match r.range_next with
+     | None -> ()
+     | Some old_next_range ->
+         old_next_range.range_prev <- Some split_r);
+    (* "left" half *)
+    r.range_next <- Some split_r;
+    r.range_end <- cut_pos
+(*    lprintf "      NEW RANGE: %Ld- OLD RANGE: %Ld-%Ld\n"
+      split_r.range_begin r.range_begin r.range_end; *)
 
-(* Assumption: we never download ranges from the middle, so present chunks
-  can only overlap the beginning of a range *)
-let set_present_block b chunk_begin chunk_end =
-  let rec iter r =
-    let range_next = r.range_next in
-(*    lprintf "iter range %Ld-%Ld\n" r.range_begin r.range_end; *)
-    (try range_received None r chunk_begin chunk_end
-      with e ->
-          lprintf_nl "EXCEPTION IN range_received: %s"
-            (Printexc2.to_string e);
-          exit 2);
-    match range_next with
-      None -> ()
-    | Some rr ->
-        iter rr
-  in
-(*  lprintf "BEFORE:  ";  print_block b; *)
-  iter b.block_ranges;
-(*  lprintf "AFTER:  ";  print_block b *)
-  ()
+(** Remove an interval from the ranges of a block, calling
+    range_received over all of them
 
+    Assumption: we never download ranges from the middle, so present
+    intervals can only overlap the beginning of ranges
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         set_present                                   *)
-(*                                                                       *)
-(*************************************************************************)
+    A (double linked) list is definitely not the most efficient
+    datastructure for this operation... *)
+
+let set_present_block b interval_begin interval_end =
+  let interval_size = interval_end -- interval_begin in
+  let old_remaining = b.block_remaining in
+  (* download can only happen at the beginning of ranges, so we must
+     first split at each interval beginning *)
+  iter_block_ranges (fun r ->
+    split_range r interval_begin) b;
+  iter_block_ranges (fun r ->
+    range_received None r interval_begin interval_end) b;
+  let new_present = old_remaining -- b.block_remaining in
+  if new_present <> interval_size then
+    lprintf_nl "set_present_block: %Ld added <> %Ld effectively added"
+      interval_size new_present
 
-let set_present s chunks =
+(** Remove a list of intervals from the ranges of a swarmer *)
 
-  apply_intervals s (fun i block_begin block_end chunk_begin chunk_end ->
+let set_present s intervals =
+  iter_intervals s (fun i block_begin block_end interval_begin interval_end ->
 (*      lprintf "interval: %Ld-%Ld in block %d [%Ld-%Ld]\n"
-      chunk_begin chunk_end i block_begin block_end;  *)
-      match s.s_blocks.(i) with
-        EmptyBlock ->
+      interval_begin interval_end i block_begin block_end;  *)
+    match s.s_blocks.(i) with
+    | EmptyBlock ->
 (*          lprintf "  EmptyBlock"; *)
-          if block_begin >= chunk_begin && block_end <= chunk_end then
-            begin
+        if block_begin >= interval_begin && block_end <= interval_end
+	then begin
 (*              lprintf " --> CompleteBlock\n"; *)
-              s.s_blocks.(i) <- CompleteBlock;
-              must_verify_block s i false;
-              add_file_downloaded None s (block_end -- block_begin)
-            end
-          else
+          s.s_blocks.(i) <- CompleteBlock;
+          must_verify_block s i;
+          add_file_downloaded None s (block_end -- block_begin)
+        end
+        else
           let b = new_block s i in
 (*          lprintf " ... set_present_block\n";  *)
-          set_present_block b chunk_begin chunk_end
-      | PartialBlock b ->
+          set_present_block b interval_begin interval_end
+    | PartialBlock b ->
 (*          lprintf "  PartialBlock\n"; *)
-          set_present_block b chunk_begin chunk_end
-      | _ ->
+        set_present_block b interval_begin interval_end
+    | CompleteBlock | VerifiedBlock ->
 (*          lprintf "  Other\n"; *)
-          ()
-  ) chunks
+        ()
+  ) intervals
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         end_present (internal)                        *)
-(*                                                                       *)
-(*************************************************************************)
+(** reverse absent/present in the list and call set_present *)
 
-let rec end_present present begin_present end_file list =
-  match list with
-    [] ->
-      let present =
-        if begin_present = end_file then present else
-          (begin_present, end_file) :: present
-      in
-      List.rev present
-  | (begin_absent, end_absent) :: tail ->
-      let present =
-        if begin_present = begin_absent then present
-        else (begin_present, begin_absent) :: present
-      in
-      end_present present end_absent end_file tail
+let set_absent s list_absent =
+(** Build the complementary list of intervals of [intervals] in 
+    [set_begin, set_end[ *)
+  let rec complementary acc set_begin set_end intervals =
+    match intervals with
+    | [] ->
+	let acc =
+          if set_begin = set_end then acc else
+            (set_begin, set_end) :: acc
+	in
+	List.rev acc
+    | (interval_begin, interval_end) :: other_intervals ->
+	let acc =
+          if set_begin = interval_begin then acc
+          else (set_begin, interval_begin) :: acc
+	in
+	complementary acc interval_end set_end other_intervals in
+  let list_present = complementary [] Int64.zero s.s_size list_absent in
+  set_present s list_present
+
+let intervals_to_string s intervals =
+  match intervals with
+  | AvailableIntervals intervals ->
+      let st = String.make (Array.length s.s_blocks) '0' in
+      iter_intervals s (fun i _ _ _ _ -> st.[i] <- '1') intervals;
+      st
+  | AvailableBitv b -> Bitv.to_string b
 
 (*************************************************************************)
 (*                                                                       *)
-(*                         set_absent                                    *)
+(*                               Uploaders                               *)
 (*                                                                       *)
 (*************************************************************************)
 
-let set_absent s list =
-(* reverse absent/present in the list and call set_present *)
-  let list =
-    match list with [] -> [ Int64.zero, s.s_size ]
-    | (t1,t2) :: tail ->
-        if t1 = zero then
-          end_present [] t2 s.s_size tail
-        else
-          end_present [zero, t1] t2 s.s_size tail
-  in
-  set_present s list
+(** (debug) output an [uploader] to current log *)
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         chunks_to_string (internal)                   *)
-(*                                                                       *)
-(*************************************************************************)
+let print_uploader up =
+  lprintf_n "  interesting complete_blocks: %d\n     " up.up_ncomplete;
+  Array.iter (fun i -> lprintf " %d " i) up.up_complete_blocks;
+  lprint_newline ();
+  lprintf_n "  interesting partial_blocks: %d\n     " up.up_npartial;
+  Array.iter (fun (i, begin_pos, end_pos) ->
+      lprintf " %d[%Ld...%Ld] " i begin_pos end_pos
+  ) up.up_partial_blocks;
+  lprint_newline ()
 
-let chunks_to_string s chunks =
-  match chunks with
-      AvailableRanges chunks ->
-        begin
-          let st = String.make (Array.length s.s_blocks) '0' in
-          apply_intervals s (fun i block_begin block_end chunk_begin chunk_end -> st.[i] <- '1') chunks;
-          st
-        end
-  | AvailableCharBitmap st -> st
-  | AvailableBitv b -> Bitv.to_string b
+(** if not [up_declared], 
+    sets [up_intervals], [up_complete_blocks], [up_ncomplete],
+    [up_partial_blocks], [up_npartial] according to [intervals],
+    resets [up_block], [up_block_begin], [up_block_end], and calls
+    [client_has_bitmap] on associated client.
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         update_uploader_chunks (internal)             *)
-(*                                                                       *)
-(*************************************************************************)
+    My feeling is that if all those fields only make sense when
+    up_declared is true, they should be regrouped in a record option.
+*)
 
-let update_uploader_chunks up chunks =
-  if not up.up_declared then
+let set_uploader_intervals up intervals =
+  if up.up_declared then
+    lprintf_nl "set_uploader_intervals: called on an already declared uploader\n"
+  else
     let t = up.up_t in
     let s = t.t_s in
-(* INVARIANT: complete_blocks must be in reverse order *)
+    (* INVARIANT: complete_blocks must be in reverse order *)
 
-    let complete_blocks = ref [] in
-    let partial_blocks = ref [] in
+  let complete_blocks = ref [] in
+  let partial_blocks = ref [] in
 
-    begin
-      match chunks with
-        AvailableRanges chunks ->
-
-          apply_intervals s (fun i block_begin block_end
-                chunk_begin chunk_end ->
-(*              lprintf "apply_intervals %d %Ld-%Ld %Ld-%Ld\n"
-                i block_begin block_end chunk_begin chunk_end; *)
-              s.s_availability.(i) <- s.s_availability.(i) + 1;
-
-              match s.s_blocks.(i) with
-                CompleteBlock | VerifiedBlock -> ()
-              | _ ->
-                  if block_begin = chunk_begin && block_end = chunk_end then
-                    complete_blocks := i :: !complete_blocks
-                  else
-                    partial_blocks :=
-                    (i, chunk_begin, chunk_end) :: !partial_blocks
-          ) chunks;
-
-      | AvailableCharBitmap string ->
-          for i = 0 to String.length string - 1 do
-            if string.[i] = '1' then
-              List.iter (fun i ->
-                  s.s_availability.(i) <- s.s_availability.(i) + 1;
-                  complete_blocks := i :: !complete_blocks
-              ) t.t_blocks_of_chunk.(i)
-          done;
-      | AvailableBitv bitmap ->
-          for i = 0 to Bitv.length bitmap - 1 do
-            if Bitv.get bitmap i then
-              List.iter (fun i ->
-                  s.s_availability.(i) <- s.s_availability.(i) + 1;
-                  complete_blocks := i :: !complete_blocks
-              ) t.t_blocks_of_chunk.(i)
-          done;
-    end;
-
-    List.iter (fun i ->
-(*        s.s_last_seen.(i) <- BasicSocket.last_time (); *)
-
-        let i = t.t_chunk_of_block.(i) in
-        t.t_last_seen.(i) <- BasicSocket.last_time ()
-
-    ) !complete_blocks;
-
-    let complete_blocks = Array.of_list !complete_blocks in
-    let partial_blocks = Array.of_list !partial_blocks in
-    up.up_chunks <- chunks;
-
-    up.up_complete_blocks <- complete_blocks;
-    up.up_ncomplete <- Array.length complete_blocks;
-
-    if Array.length partial_blocks > 0 then
-      lprintf_nl "WARNING: partial_blocks = %d" (Array.length partial_blocks);
-    up.up_partial_blocks <- partial_blocks;
-    up.up_npartial <- Array.length partial_blocks;
-
-    up.up_block <- None;
-    up.up_block_begin <- zero;
-    up.up_block_end <- zero;
-
-    up.up_declared <- true;
-
-    let bm = chunks_to_string s chunks in
-    client_has_bitmap up.up_client up.up_t.t_file bm;
-
-    if debug_all then print_uploader up
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         clean_uploader_chunks (internal)              *)
-(*                                                                       *)
-(*************************************************************************)
+  let incr_availability s i =
+    s.s_availability.(i) <- s.s_availability.(i) + 1 in
 
+  (match intervals with
+   | AvailableIntervals intervals ->
+       iter_intervals s (fun i block_begin block_end interval_begin interval_end ->
+(*              lprintf "iter_intervals %d %Ld-%Ld %Ld-%Ld\n"
+                i block_begin block_end interval_begin interval_end; *)
+         incr_availability s i;
+
+         match s.s_blocks.(i) with
+	 | CompleteBlock | VerifiedBlock -> ()
+         | EmptyBlock | PartialBlock _ ->
+             if block_begin = interval_begin && block_end = interval_end then
+               complete_blocks := i :: !complete_blocks
+             else
+               partial_blocks :=
+                 (i, interval_begin, interval_end) :: !partial_blocks
+       ) intervals
+
+   | AvailableBitv bitmap ->
+       Bitv.iteri_true (fun i ->
+         List.iter (fun j ->
+           incr_availability s j;
+           complete_blocks := j :: !complete_blocks
+         ) t.t_blocks_of_chunk.(i)
+       ) bitmap
+  );
 
-let clean_uploader_chunks up =
+  List.iter (fun i ->
+(*        s.s_last_seen.(i) <- BasicSocket.last_time (); *)
+    let i = t.t_chunk_of_block.(i) in
+    t.t_last_seen.(i) <- BasicSocket.last_time ()
+  ) !complete_blocks;
+
+  let complete_blocks = Array.of_list !complete_blocks in
+  let partial_blocks = Array.of_list !partial_blocks in
+  up.up_intervals <- intervals;
 
-  if up.up_declared then
+  up.up_complete_blocks <- complete_blocks;
+  up.up_ncomplete <- Array.length complete_blocks;
+  
+  if Array.length partial_blocks > 0 then
+    lprintf_nl "WARNING: partial_blocks = %d" (Array.length partial_blocks);
+  up.up_partial_blocks <- partial_blocks;
+  up.up_npartial <- Array.length partial_blocks;
+
+  up.up_block <- None;
+  up.up_block_begin <- zero;
+  up.up_block_end <- zero;
 
-    let decr_availability s i =
-      s.s_availability.(i) <- s.s_availability.(i) - 1
-    in
-(*          lprintf "clean_uploader_chunks:\n"; *)
+  up.up_declared <- true;
+  
+  let bm = intervals_to_string s intervals in
+  client_has_bitmap up.up_client up.up_t.t_file bm;
 
-    let t = up.up_t in
-    let s = t.t_s in
-    for i = 0 to Array.length up.up_complete_blocks - 1 do
-(*            lprintf "decr_availability complete[%d] %d\n" i
-              up.up_complete_blocks.(i); *)
-      decr_availability s up.up_complete_blocks.(i)
-    done;
-    for i = 0 to Array.length up.up_partial_blocks - 1 do
-      let b,_,_ = up.up_partial_blocks.(i) in
-(*            lprintf "decr_availability partial[%d] %d\n" i b; *)
-      decr_availability s b
-    done;
-    clear_uploader_block up;
-    up.up_declared <- false
+  if debug_all then print_uploader up
 
 (*************************************************************************)
 (*                                                                       *)
@@ -1716,15 +1652,14 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let register_uploader t client chunks =
-
+let register_uploader t client intervals =
   let up =
     {
       up_t = t;
       up_client = client;
 
       up_declared = false;
-      up_chunks = chunks;
+      up_intervals = intervals;
 
       up_complete_blocks = [||];
       up_ncomplete = 0;
@@ -1735,11 +1670,12 @@
       up_block = None;
       up_block_begin = zero;
       up_block_end = zero;
+
       up_ranges = [];
     }
   in
   HU.add uploaders_by_num up;
-  update_uploader_chunks up chunks;
+  set_uploader_intervals up intervals;
   up
 
 (*************************************************************************)
@@ -1748,34 +1684,63 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let unregister_uploader up =
-  clean_uploader_chunks up;
-  clear_uploader_block up;
-  clear_uploader_ranges up
+let clear_uploader_ranges up =
+  List.iter (fun (_,_,r) ->
+    if r.range_nuploading > 0 then
+      r.range_nuploading <- r.range_nuploading - 1
+    else
+      lprintf_nl "clear_uploader_ranges: some range_nuploading was about to become negative\n"
+  ) up.up_ranges;
+  up.up_ranges <- []
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         update_uploader                               *)
-(*                                                                       *)
-(*************************************************************************)
+let clear_uploader_block up =
+  match up.up_block with
+  | None -> ()
+  | Some b ->
+      let num = b.block_num in
+      let t = up.up_t in
+      let s = t.t_s in
+      if s.s_nuploading.(num) > 0 then
+	s.s_nuploading.(num) <- s.s_nuploading.(num) - 1
+      else
+	lprintf_nl "clear_uploader_block: some s_nuploading was about to become negative\n";
+      up.up_block <- None;
+      up.up_block_begin <- zero;
+      up.up_block_end <- zero
 
-let update_uploader up chunks =
+let clear_uploader_intervals up =
+  if up.up_declared then
+    let decr_availability s i =
+      if s.s_availability.(i) > 0 then
+	s.s_availability.(i) <- s.s_availability.(i) - 1 
+      else 
+	lprintf_nl "clear_uploader_intervals: some s_availability was about to become negative\n" in
+(*          lprintf "clean_uploader_chunks:\n"; *)
+    let t = up.up_t in
+    let s = t.t_s in
+    Array.iter (decr_availability s) up.up_complete_blocks;
+    up.up_complete_blocks <- [||];
+    up.up_ncomplete <- 0;
+    Array.iter (fun (b,_,_) -> decr_availability s b) up.up_partial_blocks;
+    up.up_partial_blocks <- [||];
+    up.up_npartial <- 0;
+    clear_uploader_block up;
+    up.up_declared <- false
 
-  clean_uploader_chunks up;
-  update_uploader_chunks up chunks
+let update_uploader_intervals up intervals =
+  clear_uploader_intervals up;
+  set_uploader_intervals up intervals
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         print_uploaders                               *)
-(*                                                                       *)
-(*************************************************************************)
+let unregister_uploader up =
+  clear_uploader_intervals up;
+  clear_uploader_ranges up
 
-let print_uploaders s =
-  let nblocks = Array.length s.s_blocks in
-  for i = 0 to nblocks - 1 do
+(** (debug) output the uploaders of a swarmer to current log *)
 
-    match s.s_blocks.(i) with
-      EmptyBlock -> lprintf "_"
+let print_uploaders s =
+  Array.iteri (fun i b ->
+    match b with
+    | EmptyBlock -> lprintf "_"
     | CompleteBlock -> lprintf "C"
     | VerifiedBlock -> lprintf "V"
     | PartialBlock b ->
@@ -1783,46 +1748,44 @@
           lprintf "X"
         else
           lprintf "%d" s.s_nuploading.(i)
-  done;
+  ) s.s_blocks;
   lprint_newline ();
-  for i = 0 to nblocks - 1 do
-
-    match s.s_blocks.(i) with
-      EmptyBlock -> lprintf "_"
+  Array.iteri (fun i b ->
+    match b with
+    | EmptyBlock -> lprintf "_"
     | CompleteBlock -> lprintf "C"
     | VerifiedBlock -> lprintf "V"
     | PartialBlock b ->
         lprintf "{ %d : %d=" b.block_num
           s.s_nuploading.(b.block_num);
-
-        let rec iter_range r =
-          lprintf "(%d)" r.range_nuploading;
-          match r.range_next with
-            None -> ()
-          | Some rr -> iter_range rr
-        in
-        iter_range b.block_ranges;
+	iter_block_ranges (fun r -> 
+          lprintf "(%d)" r.range_nuploading
+	) b;
         lprintf " }";
-
-  done;
+  ) s.s_blocks;
   lprint_newline ()
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         permute_and_return (internal)                 *)
-(*                                                                       *)
-(*************************************************************************)
+(** (see uploaders invariants above)
+    Drop the [n]th element from the [up.up_ncomplete] first elements
+    of [up.complete_blocks] by swapping it with the
+    ([up.up_ncomplete]-1)th element, then decrease [up.up_ncomplete];
+    Then return that element, after converting associated block to
+    PartialBlock if necessary.
+*)
 
 let permute_and_return up n =
+  assert (n <= up.up_ncomplete-1);
   let b = up.up_complete_blocks.(n) in
-  if debug_all then  lprintf "permute_and_return %d <> %d" n b;
-  up.up_complete_blocks.(n) <- up.up_complete_blocks.(up.up_ncomplete-1);
-  up.up_complete_blocks.(up.up_ncomplete-1) <- b;
+  if debug_all then lprintf_nl "permute_and_return %d <> %d" n b;
+  if n < up.up_ncomplete then begin
+    up.up_complete_blocks.(n) <- up.up_complete_blocks.(up.up_ncomplete-1);
+    up.up_complete_blocks.(up.up_ncomplete-1) <- b
+  end;
   up.up_ncomplete <- up.up_ncomplete - 1;
   let t = up.up_t in
   let s = t.t_s in
   match s.s_blocks.(b) with
-    EmptyBlock ->
+  | EmptyBlock ->
       let b = new_block s b in
       b, b.block_begin, b.block_end
   | PartialBlock b ->
